![WASI logo](/WASI.png)

## Agenda for the August 15 video call of WASI Subgroup

- **Where**: zoom.us
- **When**: August 15, 16:00-17:00 UTC
- **Location**: *link on calendar invite*
- **Contact**:
    - Name: Dan Gohman
    - Email: sunfish@mozilla.com

### Registration

None required if you've attended before. Email Dan Gohman to sign up if it's
your first time. The meeting is open to CG members only.

## Logistics

The meeting will be on a zoom.us video conference.
Installation is required, see the calendar invite.

## Agenda items

1. Opening, welcome and roll call
    1. Opening of the meeting
    1. Introduction of attendees
1. Find volunteers for note taking (acting chair to volunteer)
1. Adoption of the agenda
1. Proposals and discussions
    1. Weak Imports: https://github.com/WebAssembly/WASI/pull/47#issuecomment-521061962
    1. Interface description based on Module types
        - https://github.com/WebAssembly/WASI/pull/74
        - This is a rough sketch, similar to WatIDL, but stripped down, and is
          meant to be just enough to let us start describing API proposals.
    1. Meeting time
        - I received a request from someone who would like to present a proposal to hold a meeting at an APAC-friendly time.
        - We have been following the CG which held some APAC-friendly meeting times for a while but
          [dropped them due to low attendance](https://github.com/WebAssembly/meetings/blob/master/2018/CG-04-03.md#drop-apac-timezone).
        - Assuming this works for the presenter, move the time of the next meeting to 08-30 at 06:00–07:00 UTC? (This is 08-29 at 11:00pm in Pacific Time)?

1. Closure

## Agenda items for future meetings

*None*

### Schedule constraints

*None*

## Meeting Notes

Attendees:

Dan Gohman
Till Schneidereit
Alex Crichton
Luke Wagner
Jacob Gravelle
Sam Clegg
Andrew Scheidecker
Mark S. Miller
Johnnie Birch
Stefan Junker
Andrew Brown

Meeting notes:
Topic: Weak Imports: https://github.com/WebAssembly/WASI/pull/47#issuecomment-521061962
sbc: moved back to custom section design
[please fill in notes here]
MarkM: could a rename be considered—I always think of weak references
Sbc: very strong precedence in C/C++
MarkM: weak/optional imports should be brought up with TC39
Luke: [posts a link https://github.com/guybedford/proposal-weak-imports]
Dan: good question, should we rename?
Stefan: +1 on “optional”
Mark: would “optional” be confusing?
Seems like “no”
Dan: seems like consensus
Sbc: [takes an action item to rename]
Dan: anyone opposed to landing the PR once the rename is done?
[no]
Dan: let’s do it
Topic: Interface description based on Module types (https://github.com/WebAssembly/WASI/pull/74)
Dan: lots of stuff going on around OCap, and that should go on
But in parallel, we need a simple text format
This PR introduces a stripped down text format (see PR description for details)

Mark: should we introduce a term such as “compartment” to describe sets of instances which share memories and tables?
Sam: This relates to the concept of “shared-nothing linking” which we have been introducing.
Luke: In full generality, we won’t need the term compartment, because we’ll just have references and different linking approaches.
Luke: if we want wasi_unstable to become wasi, we need to spec ways to send capabilities between modules. We don’t if we just have references
Till: brings up the question if we need to support wasi_unstable, instead of just breaking it
[discussion]
Mark: This is a useful concept, whether or not it’s something 
[discussion]
Luke: getting back to the proposal, looks good for the transitional role
Dan: idea is, once we have a parser for this, we could land it, and have it be the specification
Could generate header files and documentation from it
Sbc: comments go into some kind of comment syntax?
Dan: double-semicolon
Sbc: need some kind of include mechanism
Dan: yes, good point. Want to really keep this simple
Luke: same requirement came up in conversations with Andreas about defining types in one module and using them in another
Luke: but as long this is all structural, can just agree on structure of types
Dan: 

Dan: We need to factor out types so they can be shared between multiple modules. Maybe something like a #include mechanism?
Mark: #include would be unfortunate in any kind of standards context.
Luke: We could put multiple modules in one file
Dan: Could we design a more declarative form which achieves the same goal but doesn’t have the same problem?
Mark: It’s premature to do a lot of IDL design work
Dan: agree

Timezone discussion
Till, Johnnie: conversations about voting, and people not being able to attend all meetings. Perhaps we can find a way to do votes offline to allow people to vote even if they can’t attend the meeting.
Sam: Another option is to do the vote in the meeting, but hold it open for a week or so after to allow others to vote.
Till: That does change the dynamics.
Johnnie: Would it makes sense to record the meetings?
Dan: What if we ask the CG to record their meetings? We can follow their lead.
Johnnie volunteers to take that to the CG.
