![WASI logo](/WASI.png)

## Agenda for the September 12 video call of WASI Subgroup

- **Where**: zoom.us
- **When**: September 12, 16:00-17:00 UTC
- **Location**: *link on calendar invite*
- **Contact**:
    - Name: Dan Gohman
    - Email: sunfish@mozilla.com

### Registration

None required if you've attended before. Email Dan Gohman to sign up if it's
your first time. The meeting is open to CG members only.

## Logistics

The meeting will be on a zoom.us video conference.
Installation is required, see the calendar invite.

## Agenda items

1. Opening, welcome and roll call
    1. Opening of the meeting
    1. Introduction of attendees
1. Find volunteers for note taking (acting chair to volunteer)
1. Adoption of the agenda
1. Proposals and discussions
    1. `witx` API description files:
        - https://github.com/WebAssembly/WASI/pull/74
    1. Phased API development proposal
        - https://github.com/WebAssembly/WASI/pull/88

1. Closure

## Meeting Notes

Attendees:

Dan Gohman
Sam Clegg
Pat Hickey
Yury Delendik
Artur Jamro
Mark McCaskey
Alex Crichton
Jacob Gravelle
Mingqiu Sun
Nathaniel McCallum
Luke Wagner
Johnnie Birch

Meeting notes:

Agenda seconded by Pat

Dan: Last meeting was at a different time than usual. There were only 6 attendees. We are going to resume meetings at the normal time, 1600 UTC.

Dan: Next topic is WITX.

Independent of WASI, there is a new file format called WIT from the interface-types proposal. Its a lot like WAT, but it does not have function bodies.

WITX is WIT with extensions. It has some of the types from interface-types. The idea is that WITX is not a stable format, its going to evolve to align with WIT as interface types evolves.

Fortunately our needs are pretty simple at the moment: we are adding strings, arrays, enums, and structs to the wit file.

We want WITX to be the way we specify WASI apis. It feels like a better place than the C header file we started with.

Pat: lucet-idl tool has a witx parser in development.

Working on hooking up this parser to the C and Rust interface generators.
Goal, be able to feed witx files into lucet-idl and generate C headers and Rust interfaces.

Can be used to generate libc definitions for WASI


Stefan: Does WITX have modules?

Dan: Yes, but the file we have at the moment attempts to be the exact same wasi_unstable module we have right now. Once we land this, we can immediately start factoring that module into multiple modules, and witx should support that.

Sam: Is there a way to use types from a different module?

Dan: Yes, there is a `use` mechanism, and in the PR there’s two witx files, wasi_unstable’s first declaration is to `use “typenames.witx”`

Dan: Next agenda item: Phased API development (PR 88). Apologies for getting this up late.

Stefan: Could there be a standalone parser implementation somewhere?

tdoPat: I’ll make the lucet-idl parser and validator for witx into its own crate, and that crate will live in the WASI repo.

Johnnie: I followed up on whether we can record these meetings, I talked to the W3C and they expressed the same concerns we heard here about privacy, making people feel comfortable speaking up. They suggested I talk to the WASM CG, but given that I’ve heard the same feedback from multiple places, I’m going to just drop the issue.
